#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "file.h"

int main(int argc, char **argv)
{
	int addy, stop, i;
	file_t rom, input;

	if((argc != 4) && (argc != 5))
	{
	 printf("usage: insert_asm rom.bin asm.bin start_addy <stop_addy>\n");
	 return 0;
	}
	else if(argc == 5)
	{
	 sscanf(argv[4], "%x", &stop);
	 sscanf(argv[3], "%x", &addy);	//address in rom to insert file at

	 if(stop < addy)
	 {
	  printf("Stop address occurs before start address!\n");
	  return 1;
	 }
	}
	else
	{
	 stop = 0;
	 sscanf(argv[3], "%x", &addy);	//address in rom to insert file at
	}

	strcpy(rom.filename, argv[1]);	//load files into buffers
	strcpy(input.filename, argv[2]);

	if(load_file(&rom))
	{
	 printf("A problem occured while opening the rom.\n");
	 return 1;
	}

	if(load_file(&input))
	{
	 printf("A problem occured while opening the asm file.\n");
	 return 1;
	}

	for(i = 0; i < input.size; i++) //write contents of asm file
	{
	 if(stop == (addy + i))
	 {
	  printf("Stop address reached. $%X of $%X bytes were written.\n", i, input.size);
	  printf("%s will be unaltered.\n", rom.filename);
	  return 1;
	 }
	 rom.ptr[addy + i] = input.ptr[i]; //copy one byte at a time
	}

	write_file(rom); //overwrite the old rom
	printf("Finished copying file.\n");

	return 0;
}